# Generated by sila2.code_generator; sila2.__version__: 0.10.5
from __future__ import annotations

from typing import TYPE_CHECKING, Any

from sila2.server import MetadataDict

from ..generated.deviceinfoprovider import DeviceInfo, DeviceInfoProviderBase, SetOutputFormat_Responses

if TYPE_CHECKING:
    from ..server import Server


class DeviceInfoProviderImpl(DeviceInfoProviderBase):
    def __init__(self, parent_server: Server) -> None:
        super().__init__(parent_server=parent_server)

    def get_DeviceName(self, *, metadata: MetadataDict) -> str:
        return "Arduino Thermistor Thermometer"

    def get_DeviceType(self, *, metadata: MetadataDict) -> str:
        return "Thermometer"

    def get_DeviceManufacturer(self, *, metadata: MetadataDict) -> str:
        return "DIY"

    def get_DeviceProductName(self, *, metadata: MetadataDict) -> str:
        return "Arduino Thermistor Thermometer"

    def get_DeviceVersion(self, *, metadata: MetadataDict) -> str:
        return "0.1"

    def get_DeviceFirmwareVersion(self, *, metadata: MetadataDict) -> str:
        return "0.1"

    def get_DeviceManual(self, *, metadata: MetadataDict) -> str:
        raise NotImplementedError  # TODO

    def get_DeviceQuickStartGuide(self, *, metadata: MetadataDict) -> str:
        raise NotImplementedError  # TODO

    def get_DeviceServiceManual(self, *, metadata: MetadataDict) -> str:
        raise NotImplementedError  # TODO

    def get_HardwareSettings(self, *, metadata: MetadataDict) -> str:
        raise NotImplementedError  # TODO

    def get_HardwareConfiguration(self, *, metadata: MetadataDict) -> str:
        raise NotImplementedError  # TODO

    def get_DeviceInfo(self, *, metadata: MetadataDict) -> DeviceInfo:
        raise NotImplementedError  # TODO

    def get_ServiceDates(self, *, metadata: MetadataDict) -> Any:
        raise NotImplementedError  # TODO

    def SetOutputFormat(self, OutputFormat: str, *, metadata: MetadataDict) -> SetOutputFormat_Responses:
        raise NotImplementedError  # TODO
